/***************************************************************/
//
//
//		DirectX	[ model.h ]
//
//											Author	kazuki tanaka
//											Date	2016 10/26
/*---------------------------------------------------------------
Update : 2016/10/26
			model.h̍쐬
			MODEL̏̒ǉ
			MODEL̏I̒ǉ
			MODEL̍XV̒ǉ
			MODEL̕`揈̒ǉ

Update : 2016/10/26



/*-------------------------------------------------------------*/
#ifndef _BASE_PLAYER_H_

#define _BASE_PLAYER_H_

class CModel;
class CShadow;
class CInput;

class CNavi;


// [V̎
typedef enum{

	MOTION_DEFAULT = 0,
	MOTION_1,
	MOTION_2,
	MOTION_3,
	MOTION_END,
	MOTION_MAX,

}ACTION;

typedef struct{

	float   NUM_FREME;									// [Vt[
	D3DXVECTOR3* pose;									// p[cnew

}MOTION_DATA;

// 1̃[Vi[
typedef struct{

	// 1t[̕ω
	int   NUM_KEY;										// L[
	bool  LOOP_FLAG;									// [v邩ǂ

	MOTION_DATA* keyFrameMotion;						// L[new

}MOTION;


// fNX
class CBasePlayer{
	
public:

	// vC[^Cv
	typedef enum{
		TYPE_CPU = 0,
		TYPE_PLAYER,
		TYPE_MAX,
	}PLAYER_TYPE;


	CBasePlayer();										// 3Df̃RXgN^
	~CBasePlayer();										// 3Df̃fXgN^
	
	virtual void Init( void );							// 3Df̏
	void Init( const char* TXT_FILE_NAME );				// 3Df̏
	virtual void Uninit( void );						// 3Df̏I
	virtual void Update( void );						// 3Df̍XV
	virtual void Draw( void );							// 3Df̕`揈
	
	D3DXMATRIX GetWorldMtx( void );						// 3Df̃CfbNX擾
	void       SetLife( const int value );				// qbg|Cgݒ
	int        GetLife( void );							// qbg|Cg擾
	virtual float GetLifePercent( void );				// qbg|Cg擾

	virtual void Controler( void );						// fRg[[
	virtual void AI_move( void );						// CPU̓
	virtual void ResetPlayer( void );					// vC[Zbg
	void SetType( PLAYER_TYPE type );					// vC[^Cv̐ݒ

	void Registry( CInput* controller );				// Contoroller Pointer

	// X^eBbNo֐
	static CBasePlayer* Create( void );					// 3Df̍쐬
	
	// vC[Xe[^X /////////////////////////////////////////////////////////

	PLAYER_TYPE playerType;								// vC[̃^Cv

	D3DXVECTOR3 lookAt;									// vC[_ 

	float       radius;									// a
	bool        contact;								// 蔻tO
	int         cost;									// vC[RXg
	int         teamNo;									// `[io[
	int         life;									// qbg|Cg
	int         frame;

	CModel*     parts;									// p[c(p[cnew)

	D3DXVECTOR3 rotParent;								// 
	D3DXVECTOR3 speed;									// 
	float       acceleration;							// 
	CShadow*    shadow;									// 
	CInput*     pInput;									// vC[Rg[[

	////////////////////////////////////////////////////////////////////////////////

	int   NUM_MODEL;									// ǂݍރf
	int   NUM_PARTS;									// \p[c

	float keyframe;										// [Vt[
	int   actKey;										// ݂̃L[
	int   nextKey;										// ̃L[

	// [V
	MOTION* motion;										// [V
	int     actMotion;									// ݍsĂ郂[V
	int     nextStandbyMotion;							// X^oC̃[V
	
	// X^eBbNoϐ
	
protected:

	CNavi* pNavi;

private:
		
	void SetMotionInfo( void );
	
};



#endif	//	_BASE_PLAYER_H_


